'
' Four-Variable PIC Delay Calculator
' Written by Andy Warren, 31 Jan 1995
'
' (C) 1995 Fast Forward Engineering
'
' Permission is hereby granted for all
' non-commercial use.
'

	defdbl a-z

	x = 0

	input "Number of cycles to delay:",delay
	delay = int(delay)

	if delay < 32 then goto inline

	x = delay-16

			       d = int(x/50463234)
	x = x - d * 50463234:  c = int (x/197122)
	x = x - c * 197122:    b = int (x/770)
	x = x - b * 770:       a = int (x/3)

	a = a + 1: b = b + 1: c = c + 1: d = d + 1

	x = 3*a + 770*b + 197122*c + 50463234*d - 50661121 + 8

	a$=right$("   "+str$(a),3)
	b$=right$("   "+str$(b),3)
	c$=right$("   "+str$(c),3)
	d$=right$("   "+str$(d),3)

	print
	print"       list r=dec"
	print
	print"r1     equ     [any file register]"
	print"r2     equ     r1+1"
	print"r3     equ     r2+1"
	print"r4     equ     r3+1"
	print"                    ___________________
	print"delay: movlw ";a$;"   |                   |"
	print"       movwf  r1   |                   V"
	print"       movlw ";b$;"   |       loop:  decfsz r1"
	print"       movwf  r2   |              goto   loop"
	print"       movlw ";c$;"   |              decfsz r2"
	print"       movwf  r3   |              goto   loop"
	print"       movlw ";d$;"   |              decfsz r3"
	print"       movwf  r4   |              goto   loop"
	print"           |       |              decfsz r4"
	print"           |_______|              goto   loop"

inline:

	x = delay - x

	g = int(x/2): if g = 0 then goto inline1

	for y = 1 to g
	print"                                  goto   $+1"
	next

inline1:

	if x/2 = int(x/2) then goto finis

	print"                                  nop"

finis:

	end

